(function($) {
	//全局配置(通常所有页面引用该配置，特殊页面使用mui.init({})来覆盖全局配置)
	$.initGlobal({
		swipeBack: true
	});
	var back = $.back;
	$.back = function() {
		var current = plus.webview.currentWebview();
		if (current.mType === 'main') { //模板主页面
			current.hide('fade-out', 150);
			setTimeout(function() {
				document.getElementById("title").className = 'mui-title mui-fadeout';
				current.children()[0] && current.children()[0].hide();
			}, 200);
		} else if (current.mType === 'sub') {
			if ($.targets._popover) {
				$($.targets._popover).popover('hide');
			} else {
				current.parent().evalJS('mui&&mui.back();');
			}
		} else {
			back();
		}
	}


	//return ContentWebview
	$.openNewWindow = function(name, opentype, targetUrl, title, autoshow) {
		var showWindow = (autoshow == true || autoshow != false) ? true : false;
		if (opentype == "common") {
			if (~targetUrl.indexOf('offcanvas-')) {
				var pop = ~targetUrl.indexOf('offcanvas-with-right') ? "close" : "none";
				return mui.openWindow({
					id: name,
					url: targetUrl, //this.href,
					styles: {
						zindex: 9998,
						popGesture: pop //popGesture: (String 类型 )窗口的侧滑返回功能 可取值"none"：无侧滑返回功能；"close"：侧滑返回关闭Webview窗口；"hide"：侧滑返回隐藏webview窗口。 仅iOS平台支持。
					},
					show: {
						autoShow: showWindow, //页面loaded事件发生后自动显示，默认为true      
					},
					waiting: {
						autoShow: false //自动显示等待框，默认为true
					}
				});
			} else {
				return mui.openWindow({
					id: name,
					url: targetUrl, //this.href,
					show: {
						autoShow: showWindow, //页面loaded事件发生后自动显示，默认为true      
					},
					waiting: {
						autoShow: false //自动显示等待框，默认为true
					}
				});
			}
		} else {
			//if (name && ~name.indexOf('.html')) {
			var href = targetUrl; //this.href;
			//获得共用模板组
			var template = getTemplate(name); //var template = ~href.indexOf('pullrefresh.html') ? getTemplate('pullrefresh') : getTemplate('default');
			//判断是否显示右上角menu图标；
			var showMenu = ~href.indexOf('popovers.html') ? true : false;
			//获得共用父模板
			var headerWebview = template.header;
			//获得共用子webview
			var contentWebview = template.content;
			var title = title; //this.innerText.trim();
			//通知模板修改标题，并显示隐藏右上角图标；
			mui.fire(headerWebview, 'updateHeader', {
				title: title,
				showMenu: showMenu
			});
			var reload = true;
			if (!template.loaded) {
				if (contentWebview.getURL() != targetUrl) { //this.href
					contentWebview.loadURL(targetUrl); //this.href
				} else {
					reload = false;
				}
			} else {
				reload = false;
			}
			if (showWindow == true) {
				(!reload) && contentWebview.show();
				headerWebview.show('slide-in-right', 150);
			}
		}
	};


	//	$.openSubWindowByTemplate = function(templateId, templageUrl, targetUrl, title, successfunc) {
	//		//取得模版
	//		var template = getTemplate(templateId, templageUrl, targetUrl);
	//		//获得父模板
	//		var headerWebview = template.header;
	//		//获得子webview
	//		var contentWebview = template.content;
	//		if (!template.loaded) {
	//			template.header.addEventListener('loaded', function() {
	//				template.header.loaded = true;
	//				if (template.header.loaded && template.content.loaded) {
	//					template.loaded = true;
	//					setTimeout(function() {
	//						$.openSubWindowByTemplate(templateId, templageUrl, targetUrl, title, successfunc);
	//					}, 2000);
	//				}
	//			});
	//			template.content.addEventListener('loaded', function() {
	//				template.content.loaded = true;
	//				if (template.header.loaded && template.content.loaded) {
	//					template.loaded = true;
	//					setTimeout(function() {
	//						$.openSubWindowByTemplate(templateId, templageUrl, targetUrl, title, successfunc);
	//					}, 2000);
	//				}
	//			});
	//
	//		} else {
	//			console.log("模版加载完成");
	//			//通知模板修改标题，并显示隐藏右上角图标；
	//			mui.fire(headerWebview, 'updateHeader', {
	//				title: title
	//			});
	//			var reload = true;
	//			if (contentWebview.getURL() != targetUrl) {
	//				console.log("重新加载！");
	//				contentWebview.loadURL(targetUrl);
	//			} else {
	//				reload = false;
	//			}
	//			console.log(contentWebview.id);
	//			successfunc.call(contentWebview);
	//			(!reload) && contentWebview.show();
	//			headerWebview.show('slide-in-right', 150);
	//		}
	//		return template;
	//	}


	$.openSubWindow = function(templateId, targetUrl, title, hasReload) {
		//取得模版
		var template = getTemplate(templateId);
		//获得父模板
		var headerWebview = template.header;
		//获得子webview
		var contentWebview = template.content;
		//通知模板修改标题，并显示隐藏右上角图标；
		mui.fire(headerWebview, 'updateHeader', {
			title: title
				//showMenu: showMenu
		});
		var reload = true;
		if ((contentWebview.getURL() != targetUrl) || hasReload) {
			contentWebview.loadURL(targetUrl);
		} else {
			reload = false;
		}
		(!reload) && contentWebview.show();
		headerWebview.show('slide-in-right', 150);
		return template;
	}
})(mui);

/**
 * toggle
 */
window.addEventListener('toggle', function(event) {
	if (event.target.id === 'M_Toggle') {
		var isActive = event.detail.isActive;
		var table = document.querySelector('.mui-table-view');
		var card = document.querySelector('.mui-card');
		if (isActive) {
			card.appendChild(table);
			card.style.display = '';
		} else {
			var content = document.querySelector('.mui-content');
			content.insertBefore(table, card);
			card.style.display = 'none';
		}
	}
});

//模版调用
var templates = {};
var getTemplate = function(name, header, content, loading) {
	var template = templates[name];
	if (!template) {
		//预加载共用父模板；
		var headerWebview = mui.preload({
			url: header,
			id: name + "-main",
			styles: {
				popGesture: "hide",
				bottom: '0x',
			},
			extras: {
				mType: 'main',
			}
		});
		//预加载共用子webview
		var subWebview = mui.preload({
			url: !content ? "" : content,
			id: name + "-sub",
			styles: {
				top: '45px',
				bottom: '0px',
			},
			extras: {
				mType: 'sub',
			},
		});

		subWebview.hide();
		headerWebview.append(subWebview);
		//iOS平台支持侧滑关闭，父窗体侧滑隐藏后，同时需要隐藏子窗体；
		if (mui.os.ios) { //5+父窗体隐藏，子窗体还可以看到？不符合逻辑吧？
			headerWebview.addEventListener('hide', function() {
				subWebview.hide("none");
			});
		}
		templates[name] = template = {
			name: name,
			header: headerWebview,
			content: subWebview,
			loaded: loading
		};
	}
	return template;
};