(function(w) {
	var server = "http://demo.5any.com/Classroom/AppService/DataApi/GetData/UpdateInfoBLL/GetUpdateInfo", //获取升级描述文件服务器地址 
		localDir = "update",
		localFile = "update.json", //本地保存升级描述目录和文件名
		keyUpdate = "updateCheck", //取消升级键名
		keyAbort = "updateAbort", //忽略版本键名
		checkInterval = 3 * 24 * 60 * 60 * 1000, //升级检查间隔，单位为ms,7天为7*24*60*60*1000=60480000, 如果每次启动需要检查设置值为0
		dir = null;

	/**
	 * 准备升级操作
	 */
	initUpdate = function() {
		checkUpdate();
	}

	/**
	 * 手动检测升级
	 */
	w.requestUpdate = function() {
		checkRequestUpdate();
	}


	/**
	 * 手动检测程序升级
	 */
	function checkRequestUpdate() {
		console.log("手动");
					console.log(server);
		mui.getJSON(server, {}, function(data) {
			checkRequestUpdateData(data.Result);
		});
	}


	/**
	 * 检测程序升级
	 */
	function checkUpdate() {
		console.log("自动");
		// 判断升级检测是否过期
		var lastcheck = plus.storage.getItem(keyUpdate);
		if (lastcheck) {
			var dc = parseInt(lastcheck);
			var dn = (new Date()).getTime();
			if (dn - dc < checkInterval) { // 未超过上次升级检测间隔，不需要进行升级检查
				return;
			}
			// 取消已过期，删除取消标记
			plus.storage.removeItem(keyUpdate);
		} else {
			plus.storage.setItem(keyUpdate, (new Date()).getTime().toString());
		}

		mui.getJSON(server, {}, function(data) {

			checkUpdateData(data.Result);
		});
	}

	/**
	 * 检查升级数据
	 */
	function checkUpdateData(j) {
		//当前客户端版本号
		var curVer = plus.runtime.version,
			inf = j[plus.os.name];
		if (inf) {
			var srvVer = inf.version;
			// 判断是否存在忽略版本号
			var vabort = plus.storage.getItem(keyAbort);
			if (vabort && srvVer == vabort) {
				// 忽略此版本
				return;
			}
			// 判断是否需要升级
			if (compareVersion(curVer, srvVer)) {
				// 提示用户是否升级
				plus.ui.confirm(inf.note, function(i) {
					if (0 == i) {
						plus.runtime.openURL(inf.url);
					} else if (1 == i) {
						plus.storage.setItem(keyAbort, srvVer);
						plus.storage.setItem(keyUpdate, (new Date()).getTime().toString());
					} else {
						plus.storage.setItem(keyUpdate, (new Date()).getTime().toString());
					}
				}, inf.title, ["立即更新", "跳过此版本", "取　　消"]);
			} else {
				console.log("已经是最新版本了。");
			}
		}
	}

	/**
	 * 手动检查升级数据
	 */
	function checkRequestUpdateData(j) {
		//当前客户端版本号
		var osname = plus.os.name;

		if (osname == "iOS" || osname == "IOS")
		{
			osname = "IOS";
		}

		console.log(osname);
		var curVer = plus.runtime.version,
			inf = j[osname];
		console.log(inf.version);
		if (inf) {
			var srvVer = inf.version;
			// 判断是否需要升级
			console.log(curVer + " " + srvVer);
			if (compareVersion(curVer, srvVer)) {
				// 提示用户是否升级
				plus.ui.confirm(inf.note, function(i) {
					if (0 == i) {
						plus.runtime.openURL(inf.url);
					} else if (1 == i) {
						plus.storage.setItem(keyAbort, srvVer);
						plus.storage.setItem(keyUpdate, (new Date()).getTime().toString());
					} else {
						plus.storage.setItem(keyUpdate, (new Date()).getTime().toString());
					}
				}, inf.title, ["立即更新", "跳过此版本", "取　　消"]);
			} else {
				plus.nativeUI.toast("已经是最新版本了");
			}
		}
	}

	/**
	 * 比较版本大小，如果新版本nv大于旧版本ov则返回true，否则返回false
	 * @param {String} ov
	 * @param {String} nv
	 * @return {Boolean}
	 */
	function compareVersion(ov, nv) {
		if (!ov || !nv || ov == "" || nv == "") {
			return false;
		}
		var b = false,
			ova = ov.split(".", 4),
			nva = nv.split(".", 4);
		for (var i = 0; i < ova.length && i < nva.length; i++) {
			var so = ova[i],
				no = parseInt(so),
				sn = nva[i],
				nn = parseInt(sn);
			if (nn > no || sn.length > so.length) {
				return true;
			} else if (nn < no) {
				return false;
			}
		}
		if (nva.length > ova.length && 0 == nv.indexOf(ov)) {
			return true;
		}
	}

	mui.plusReady(initUpdate);

})(window);